/** Copyright (C) 2017 by Bundesanstalt für Gewässerkunde
 * Software engineering by
 *  Björnsen Beratende Ingenieure GmbH
 *  Dr. Schumacher Ingenieurbüro für Wasser und Umwelt
 *
 * This file is Free Software under the GNU AGPL (>=v3)
 * and comes with ABSOLUTELY NO WARRANTY! Check out the
 * documentation coming with Dive4Elements River for details.
 */
package org.dive4elements.river.artifacts.sinfo.flood_duration;

import org.dive4elements.artifactdatabase.state.Facet;
import org.dive4elements.river.artifacts.common.ResultFacet;
import org.dive4elements.river.artifacts.states.DefaultState.ComputeType;

/**
 * @author Domenico Nardi Tironi
 */
final class FloodDurationFacet extends ResultFacet {

    private static final long serialVersionUID = 1L;

    protected int waterlevelIndex = -1; // for custom result

    private FloodDurationFacet() {
        // required for clone operation deepCopy()
    }

    public FloodDurationFacet(final int facetIndex, final int resultIndex, final int waterlevelIndex, final String name, final String description,
            final ComputeType type, final String yAxisLabelKey, final String hash, final String stateId) {
        super(facetIndex, resultIndex, name, description, yAxisLabelKey, type, stateId, hash);

        this.waterlevelIndex = waterlevelIndex;
    }

    public int getWaterlevelIndex() {
        return this.waterlevelIndex;
    }

    /** Copy deeply. */
    @Override
    public Facet deepCopy() {
        // FIXME: why not simply use the full constructor instead?
        final FloodDurationFacet copy = new FloodDurationFacet();
        // FIXME: why does DataFacet does not override set? Bad access to variables of parent!
        copy.set(this);
        copy.type = this.type;
        copy.hash = this.hash;
        copy.stateId = this.stateId;
        copy.waterlevelIndex = this.waterlevelIndex;
        return copy;
    }
}